<template>
  <a-card :bordered="false">
    <div class="table-page-search-wrapper">
      <a-form layout="inline">
        <a-row :gutter="48">
          <a-col :md="5" :sm="15">
            <a-form-item label="展厅主题">
              <a-input placeholder="请输入展厅主题" v-model="queryParam.title"/>
            </a-form-item>
          </a-col>
          <a-col :md="8" :sm="24">
            <span class="table-page-search-submitButtons">
              <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
              <a-button style="margin-left: 8px" @click="() => queryParam = {}">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <div class="table-operator">
      <a-button v-if="addEnable" type="primary" icon="plus" @click="$refs.modal.add()">新建</a-button>
      <a-dropdown v-if="removeEnable&&selectedRowKeys.length > 0">
        <a-button type="danger" icon="delete" @click="delByIds(selectedRowKeys)">删除</a-button>
      </a-dropdown>
    </div>
    <s-table
      size="default"
      ref="table"
      :columns="columns"
      :data="loadData"
      rowKey='id'
      :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}'>
    >
      <span slot='visitType' slot-scope='text'>
        {{ text | visitType }}
      </span>
      <span slot='status' slot-scope='text,record'>
        {{ record.status === 1?'已通过':'已取消' }}
      </span>
      <span slot='persons' slot-scope='text,record'>
        <a @click='handlePersons(record)'>查看</a>
      </span>
      <span slot="action" slot-scope="text, record">
        <a @click='handleInfo(record)'>详情</a>
        <a-divider type="vertical" />
        <a v-if="editEnabel" @click="handleEdit(record)">编辑</a>
        <a-divider type="vertical" />
        <a v-if="removeEnable" @click="delByIds([record.id])">删除</a>
        <a-divider type="vertical" />
        <a-tag  @click='verifyReject(record.id)' v-if=' rejectEnable && (record.status == 0 || record.status == 1)'
              color='volcano'>驳回</a-tag>
      </span>
    </s-table>
    <showroomRecord-modal ref="modal" @ok="handleOk"/>

    <a-modal v-model='visible' title='参观人员' width='800px' :footer="null" >
      <a-table :columns='personColumns'
               size='default'
               ref='table'
               style='width: 600px;margin-left: 40px'
               :data-source='personData'>
      </a-table>
    </a-modal>

    <a-modal
      title='驳回'
      :visible='rejectModalVisible'
      :confirm-loading='rejectConfirmLoading'
      @ok='rejectHandleOk'
      @cancel='rejectHandleCancel'
      cancelText='取消'
      okText='确认'
    >
      <div class='rejectView'>
        <div class='label'>驳回原因</div>
        <a-input class='content' v-model='rejectContent' placeholder='请输入驳回原因' />
      </div>
    </a-modal>
  </a-card>
</template>

<script>
    import {STable} from '@/components'

    import {delShowroomRecord,getShowroomRecordList,saveShowroomRecord} from '@/api/admin/meeting/showroomRecord'
    import ShowroomRecordModal from './modules/ShowroomRecordModal.vue'
    import {checkPermission} from '@/utils/permissions'
    import { getDictArray } from '@/utils/dict'

    const typeMap = {}
    export default {
  name: 'TableList',
  components: {
    STable,
    ShowroomRecordModal
  },
  data () {
    return {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      form: this.$form.createForm(this),
      mdl: {},
      rejectModalVisible: false,
      rejectConfirmLoading: false,
      // 高级搜索 展开/关闭
      advanced: false,
      // 查询参数
      queryParam: {},
      visible:false,
      personData:[],
      personColumns:[
        {
          title: '名称',
          dataIndex: 'name'
        },
        {
          title: '职位',
          dataIndex: 'job'
        },
        {
          title: '展厅名称',
          dataIndex: 'phone'
        }
      ],
      // 表头
      columns: [
        {
          title: '展厅名称',
          dataIndex: 'showRoomName'
        },

        {
          title: '展厅主题',
          dataIndex: 'title'
        },
        {
          title: '来参观人员',
          dataIndex: 'persons',
          scopedSlots: { customRender: 'persons' }

        },
        {
          title: '参观目的',
          dataIndex: 'visitType',
          scopedSlots: { customRender: 'visitType' }
        },
        {
          title: '预约-开始时间',
          dataIndex: 'startTime',
          sorter: true
        },
        {
          title: '预约-结束时间',
          dataIndex: 'endDate',
          sorter: true
        },
        {
          title: '预约状态',
          dataIndex: 'status',
          scopedSlots: { customRender: 'status' }

        },
        {
          title: '操作',
          width: '300px',
          dataIndex: 'action',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        return getShowroomRecordList(Object.assign(parameter, this.queryParam))
      },
      selectedRowKeys: [],
      selectedRows: [],
      typeMap,
      addEnable: checkPermission('meeting:showroomRecord:add'),
      editEnabel: checkPermission('meeting:showroomRecord:edit'),
      removeEnable: checkPermission('meeting:showroomRecord:remove'),
      rejectEnable: checkPermission('meeting:showroomRecord:reject')
    }
  },
  filters: {



    visitType(Type) {
      return typeMap[Type].text
    },
  },
  async created () {
    const TypeData = await getDictArray('visit_type')
    TypeData.map(d => {
      typeMap[d.dictValue] = { text: d.dictLabel }
    })
  },
  methods: {

    // 展厅预约驳回
    verifyReject(id) {
      this.rejectModalId = id
      this.rejectModalVisible = true
    },

    rejectHandleOk() {
      console.log('rejectHandleOk', this.rejectContent)
      let id = this.rejectModalId
      let cancelResaon = this.rejectContent
      // 校验必填
      if (!this.rejectContent) {
        this.$message.error('驳回原因不能为空!')
        return
      }
      // 设置确认加载状态
      this.rejectConfirmLoading = true
      // 调用接口
      saveShowroomRecord({
        id,
        status: 4,
        rejectContent:this.rejectContent,
      }).then(res => {
        if (res.code === 0) {
          this.$message.success('操作成功')
          this.rejectHandleCancel()
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },

    rejectHandleCancel() {
      this.rejectModalId = null
      this.rejectModalVisible = false
      this.rejectConfirmLoading = false
      this.rejectContent = null
    },

    handleInfo(record){
      this.$router.push({ name: 'showroomRecordInfo', query: { id: record.id } })

    },

    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },

    handlePersons(record){
      this.visible =true
      console.log(record.persons)
      this.personData =  JSON.parse(record.persons)
    },


    itemHandleOk(){

    },
    handleAdd () {
      this.$refs.modal.add()
    },
    handleEdit (record) {
      this.$refs.modal.edit(record)
    },
    handleOk () {
      this.$refs.table.refresh(true)
      console.log('handleSaveOk')
    },
    delByIds (ids) {
      delShowroomRecord({ ids: ids.join(',') }).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    }
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>
